; Pavel~sfinks
;18   (RA1) - 
;17  -   
;       PIC16F84
; 8 MHz                a_biv @ list . ru
	LIST     P=PIC16F84
	INCLUDE  <P16F84.INC>
	__CONFIG _CP_OFF & _PWRTE_OFF & _WDT_ON & _XT_OSC

CNTRLPORT       EQU     05h

V1              EQU     0Ch
V2              EQU     0Dh
V3              EQU     0Eh
V4              EQU     0Fh
DISPL		EQU	10h
PAUSE		EQU	11h
COUNTER		EQU	12h
T		EQU	13h
L		EQU	14h
TW		EQU	15h
LW		EQU	16h
LT		EQU	17h
LM		EQU	18h
D7		EQU	19h
D8		EQU	1Ah
D9		EQU	1Bh
DIG		EQU	1Ch
C1		EQU	1Dh
C8		EQU	24h
C9		EQU	25h
EEADR1		EQU	26h  ;   
EEDATA1		EQU	27h  ;  
I1		EQU	28h
I2		EQU	29h
IFR		EQU	2Ah
W_TEMP		EQU	2Bh
STATUS_TEMP	EQU	2Ch
MUS_NUM         EQU	2Dh
KDIV		EQU	0E8h


        ORG     0
        GOTO BEGIN

	ORG	04h
	MOVLW	KDIV
	MOVWF	TMR0       ; 0:=08
	MOVWF	W_TEMP    ; ,   
	SWAPF	STATUS,0
	MOVWF	STATUS_TEMP  ;    
	BCF	INTCON,2       ;   0

	DECFSZ	LT,F
	GOTO	LI2
	MOVLW	0C8h
	MOVWF	LT
	DECFSZ	LW,F
	GOTO	LI2
	INCF	EEADR1,1
	;MOVF	EEADR1,0

	
	;MOVWF	EEADR
	;BSF	STATUS,RP0
	;BSF	EECON1,RD
	;BCF	STATUS,RP0
	;MOVF	EEDATA,0

        MOVF MUS_NUM,W
	SUBLW 0 
	BTFSC STATUS,Z
	CALL mus0

	MOVF MUS_NUM,W
	SUBLW 1
	BTFSC STATUS,Z
	call mus1

;	MOVF MUS_NUM,W
;	SUBLW 2
;	BTFSC STATUS,Z
;	call mus2


	MOVF	EEDATA1,0
	SUBLW	0FFh
	BTFSC	STATUS,2
	GOTO	LI4
	MOVF	EEDATA1,0
	ANDLW	B'00011111'

	;ADDLW	27h
	;MOVWF	EEADR
	;BSF	STATUS,RP0
	;BSF	EECON1,RD
	;BCF	STATUS,RP0
	;MOVF	EEDATA,0	

	call chast_table

	MOVWF	T
	MOVWF	TW
	MOVF	EEDATA1,0
	ANDLW	B'11100000'
	MOVWF	LW
	;SWAPF	LW,1
	;RLF	LW,1
	MOVLW	KDIV
	MOVWF	TMR0

	GOTO	LI2
LI4	BSF	STATUS,RP0
	CLRF	INTCON
	BCF	STATUS,RP0
	BCF	CNTRLPORT,0
	RETFIE
	
LI2	MOVF	T,0
	SUBLW	0
	BTFSS	STATUS,2
	GOTO	LI3
	BCF	CNTRLPORT,0
	GOTO	LI1
LI3	DECFSZ	TW,F
	GOTO	LI1
	COMF	CNTRLPORT,0
	ANDLW	01h
	MOVWF	CNTRLPORT
	MOVF	T,0
	MOVWF	TW

LI1	SWAPF	STATUS_TEMP,0
	MOVWF	STATUS
	SWAPF	W_TEMP,1
	SWAPF	W_TEMP,0
	RETFIE

;-----------------------------------------------------
	ORG	48h             ; =========================== 

BEGIN	BCF     STATUS,RP0    
        CLRF    PORTA    
        MOVLW   B'00000010'        ;    RA1
        BSF     STATUS,RP0    
        MOVWF   TRISA        

        BCF     STATUS,RP0    
        CLRF    PORTB     
        MOVLW   B'00000000'        
        BSF     STATUS,RP0    
        MOVWF   TRISB           ;  

	MOVLW	B'00001000'      ; , 0- 1:1
	MOVWF	OPTION_REG       ;   8/4/256= 7812,5   128 .
	BCF     STATUS,RP0
;-----------------------------------
	CLRF	MUS_NUM              ;   - 0
;-----------------------------------
L1	BTFSC	CNTRLPORT,1
	GOTO	L1
	MOVLW	0h
	MOVWF	V1
L2	MOVLW	0Ah
	MOVWF	V2

L3	BTFSC	CNTRLPORT,1
	GOTO	L1                        ;   /  /  ...
	DECFSZ	V2,F
	GOTO	L3
	DECFSZ	V1,F
	GOTO	L2
;-------------------------------------    
	BSF	STATUS,RP0
	MOVLW	B'10100000'          ;    R0
	MOVWF	INTCON
	BCF	STATUS,RP0
	MOVLW	01h
	MOVWF	LT
	MOVWF	LW
	MOVLW	0Fh
	MOVWF	LM
	MOVLW	0FFh
	MOVWF	EEADR1            ;    
L4	CLRWDT
	BTFSC	INTCON,5       ;  
	GOTO	L4

	INCF	MUS_NUM,1       ; 
        MOVF	MUS_NUM,0
	SUBLW	2
	BTFSC	STATUS,Z
	CLRF	MUS_NUM

	GOTO	L1                ;    ??

mus0    MOVF	EEADR1,0        ;   ?????
        call    mus0_table
	MOVWF	EEDATA1
	RETLW	0

mus1    MOVF	EEADR1,0
        call    mus1_table
	MOVWF	EEDATA1
	RETLW	0

;mus2    MOVF	EEADR1,0
;        call    mus2_table
;	MOVWF	EEDATA1
;	RETLW	0

mus0_table
	addwf pcl,1
	RETLW 0x91
	RETLW 0x40
	RETLW 0x40
	RETLW 0x40
	RETLW 0x53
	RETLW 0x54
	RETLW 0x53
	RETLW 0x91
	RETLW 0x40
	RETLW 0x40
	RETLW 0x40
	RETLW 0x53
	RETLW 0x54
	RETLW 0x53
	RETLW 0x51
	RETLW 0x53
	RETLW 0x54
	RETLW 0x53
	RETLW 0x51
	RETLW 0x53
	RETLW 0x54
	RETLW 0x53
	RETLW 0x51
	RETLW 0x53
	RETLW 0x54
	RETLW 0x53
	RETLW 0x51
	RETLW 0x40
	RETLW 0x4C
	RETLW 0x40
	RETLW 0x8F
	RETLW 0x40
	RETLW 0x40
	RETLW 0x40
	RETLW 0x40
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0x00


mus1_table
	addwf pcl,1
	RETLW 0x8C
	RETLW 0x4D
	RETLW 0x45
	RETLW 0x4A
	RETLW 0x4D
	RETLW 0x4F
	RETLW 0x48
	RETLW 0x4C
	RETLW 0x8D
	RETLW 0x4A
	RETLW 0x4D
	RETLW 0x51
	RETLW 0x52
	RETLW 0x52
	RETLW 0x51
	RETLW 0x4F
	RETLW 0x4D
	RETLW 0x45
	RETLW 0x4A
	RETLW 0x4D
	RETLW 0x4C
	RETLW 0x4F
	RETLW 0x48
	RETLW 0x8A
	RETLW 0x40
	RETLW 0x40
	RETLW 0x40
	RETLW 0x40
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0xFF
	RETLW 0x00

chast_table                ;  
	addwf pcl,1
        RETLW 0x0
	RETLW 0x9F
	RETLW 0x96
	RETLW 0x8E
	RETLW 0x86
	RETLW 0x7E
	RETLW 0x77
	RETLW 0x71
	RETLW 0x6A
	RETLW 0x64
	RETLW 0x5F
	RETLW 0x59
	RETLW 0x54
	RETLW 0x50
	RETLW 0x4B
	RETLW 0x47
	RETLW 0x43
	RETLW 0x3F
	RETLW 0x3C
	RETLW 0x38
	RETLW 0x35
	RETLW 0x32
	RETLW 0x2F
	RETLW 0x2D
	RETLW 0x2A




	END