;      www.picmaster.narod.ru
;
;       PIC16F84
;
; Osc     - XT 
; WDT     - On
; PWRTE   - Off
; CP      - Off
;   MPASM
;  
;     Data memory:
;
; 91 40 40 40 53 54 53 91 -|
; 40 40 40 53 54 53 51 53  |   
; 54 53 51 53 54 53 51 53  |       ECD.EXE
; 54 53 51 40 4C 40 8F 40  |
; 40 40 40 FF FF FF FF 00 -
; 9F 96 8E 86 7E 77 71 6A -|       
; 64 5F 59 54 50 4B 47 43  |
; 3F 3C 38 35 32 2F 2D 2A -




INDO		EQU	0h
TMR0            EQU     01h
PC              EQU     02h
STATUS          EQU     03h
OPTION_REG	EQU	81h
INTCON		EQU	0Bh
FSR             EQU     04h
CNTRLPORT       EQU     05h
DATAPORT        EQU     06h
EEDATA		equ	08h
EEADR		equ	09h
EECON1		equ	088h
RD		equ	0
C               EQU     0h
DC              EQU     1h
Z               EQU     2h
PD              EQU     3h
TO              EQU     4h
RP              EQU     5h
V1              EQU     0Ch
V2              EQU     0Dh
V3              EQU     0Eh
V4              EQU     0Fh
DISPL		EQU	10h
PAUSE		EQU	11h
COUNTER		EQU	12h
T		EQU	13h
L		EQU	14h
TW		EQU	15h
LW		EQU	16h
LT		EQU	17h
LM		EQU	18h
D7		EQU	19h
D8		EQU	1Ah
D9		EQU	1Bh
DA		EQU	1Ch
DIG		EQU	1Ch
C1		EQU	1Dh
C8		EQU	24h
C9		EQU	25h
EEADR1		EQU	26h
EEDATA1		EQU	27h
I1		EQU	28h
I2		EQU	29h
IFR		EQU	2Ah
W_TEMP		EQU	2Bh
STATUS_TEMP	EQU	2Ch
TRISA           EQU     85h
TRISB           EQU     86h
INIT_OPTION	EQU	B'00001000'
INIT_INTCON	EQU	B'10100000'
INITA           EQU     B'00000010'
INITB           EQU     B'00000000'
KDIV		EQU	0E8h
        ORG     0
        GOTO BEGIN

	ORG	04h

	MOVLW	KDIV
	MOVWF	TMR0        ; 8 -> 0
	MOVWF	W_TEMP      ;
	SWAPF	STATUS,0    ;
	MOVWF	STATUS_TEMP ;   
	BCF	INTCON,2    ;   0

	DECFSZ	LT
	GOTO	LI2
	MOVLW	0C8h
	MOVWF	LT
	DECFSZ	LW
	GOTO	LI2

	INCF	EEADR1,1   ;  
	MOVF	EEADR1,0
	MOVWF	EEADR
	BSF	STATUS,RP
	BSF	EECON1,RD
	BCF	STATUS,RP
	MOVF	EEDATA,0
	MOVWF	EEDATA1
	SUBLW	0FFh      ;   0 -  
	BTFSC	STATUS,2
	GOTO	LI4          ;   .

	MOVF	EEDATA1,0
	ANDLW	B'00011111'  ;  3  
	ADDLW	27h          ; + 27h
	MOVWF	EEADR        ;    ()
	BSF	STATUS,RP
	BSF	EECON1,RD
	BCF	STATUS,RP
	MOVF	EEDATA,0	
	MOVWF	T          ;  
	MOVWF	TW         ;  
	MOVF	EEDATA1,0
	ANDLW	B'11100000'  ; 
	MOVWF	LW         ;    3  
	;SWAPF	LW,1
	;RLF	LW,1
	MOVLW	KDIV       ; 8 -> 0
	MOVWF	TMR0
	GOTO	LI2
           ;========


LI4	BSF	STATUS,RP
	CLRF	INTCON
	BCF	STATUS,RP
	BCF	CNTRLPORT,0
	RETFIE
  ;=============================
	
LI2	MOVF	T,0         ;   
	SUBLW	0           ;  
	BTFSS	STATUS,2    
	GOTO	LI3         ;     0
	BCF	CNTRLPORT,0  ; 0-
	GOTO	LI1          ; RETFIE

LI3	DECFSZ	TW     ; 
	GOTO	LI1          ; RETFIE  0
	COMF	CNTRLPORT,0  ;     W
	ANDLW	01h          ;    0 .
	MOVWF	CNTRLPORT    ;    
	MOVF	T,0          ; T -> TW
	MOVWF	TW

LI1	SWAPF	STATUS_TEMP,0  ; 
	MOVWF	STATUS
	SWAPF	W_TEMP,1
	SWAPF	W_TEMP,0
	RETFIE
;==================================================

	ORG	48h
BEGIN	BCF     STATUS,RP    
        CLRF    CNTRLPORT    
        MOVLW   INITA        
        BSF     STATUS,RP    
        MOVWF   TRISA        
        BCF     STATUS,RP    
        CLRF    DATAPORT     
        MOVLW   INITB        
        BSF     STATUS,RP    
        MOVWF   TRISB        
	MOVLW	INIT_OPTION
	MOVWF	OPTION_REG
	BCF     STATUS,RP
L1	BTFSC	CNTRLPORT,1
	GOTO	L1
	MOVLW	0h
	MOVWF	V1
L2	MOVLW	0Ah
	MOVWF	V2
L3	BTFSC	CNTRLPORT,1
	GOTO	L1
	DECFSZ	V2
	GOTO	L3
	DECFSZ	V1
	GOTO	L2
	BSF	STATUS,RP
	MOVLW	INIT_INTCON
	MOVWF	INTCON
	BCF	STATUS,RP
	MOVLW	01h
	MOVWF	LT
	MOVWF	LW
	MOVLW	0Fh
	MOVWF	LM
	MOVLW	0FFh
	MOVWF	EEADR1
L4	CLRWDT
	BTFSC	INTCON,5
	GOTO	L4
	GOTO	BEGIN
	END